# Сообщаем Gitlab CI, что мы будем использовать Docker при сборке.
image: docker:latest
services:
    - docker:dind

# Описываем, из каких ступеней будет состоять наша непрерывная интеграция:
#  - сборка Docker-образа,
#  - прогон тестов Django,
#  - выкат на боевой сервер.
stages:
    - build
    - deploy


before_script:
  - apk add  openjdk8
  - apk add --update ca-certificates && rm -rf /var/cache/apk/* && \
    find /usr/share/ca-certificates/mozilla/ -name "*.crt" -exec keytool -import -trustcacerts \
    -keystore /usr/lib/jvm/java-1.8-openjdk/jre/lib/security/cacerts -storepass changeit -noprompt \
    -file {} -alias {} \; && \
    keytool -list -keystore /usr/lib/jvm/java-1.8-openjdk/jre/lib/security/cacerts --storepass changeit
  - export MAVEN_VERSION=3.5.4
  - export MAVEN_HOME=/usr/lib/mvn
  - export PATH=$MAVEN_HOME/bin:$PATH
  - apk add maven -y
  - apk add --no-cache py-pip
  # логин в Gitlab Docker registry
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY

 #Сборка Docker-образа
build:
 stage: build
 only:
     - master
 script:
#      - docker-compose build
#      - docker-compose push
     - mvn package -DskipTests
     - docker build -t $CI_REGISTRY_REPOSITORY/account-service ./account-service
     - docker push $CI_REGISTRY_REPOSITORY/account-service

     - docker build -t $CI_REGISTRY_REPOSITORY/auth-service ./auth-service
     - docker push $CI_REGISTRY_REPOSITORY/auth-service

     - docker build -t $CI_REGISTRY_REPOSITORY/config ./config
     - docker push $CI_REGISTRY_REPOSITORY/config

     - docker build -t $CI_REGISTRY_REPOSITORY/document-service ./document-service
     - docker push $CI_REGISTRY_REPOSITORY/document-service

     - docker build -t $CI_REGISTRY_REPOSITORY/gateway ./gateway
     - docker push $CI_REGISTRY_REPOSITORY/gateway

     - docker build -t $CI_REGISTRY_REPOSITORY/marking-service ./marking-service
     - docker push $CI_REGISTRY_REPOSITORY/marking-service

     - docker build -t $CI_REGISTRY_REPOSITORY/monitoring ./monitoring
     - docker push $CI_REGISTRY_REPOSITORY/monitoring

     - docker build -t $CI_REGISTRY_REPOSITORY/motp-service ./motp-service
     - docker push $CI_REGISTRY_REPOSITORY/motp-service


     - docker build -t $CI_REGISTRY_REPOSITORY/motp-service ./motp-service
     - docker push $CI_REGISTRY_REPOSITORY/motp-service


     - docker build -t $CI_REGISTRY_REPOSITORY/notification-service ./notification-service
     - docker push $CI_REGISTRY_REPOSITORY/notification-service

     - docker build -t $CI_REGISTRY_REPOSITORY/postgres ./postgres
     - docker push $CI_REGISTRY_REPOSITORY/postgres

     - docker build -t $CI_REGISTRY_REPOSITORY/registry ./registry
     - docker push $CI_REGISTRY_REPOSITORY/registry

     - docker build -t $CI_REGISTRY_REPOSITORY/statistics-service ./statistics-service
     - docker push $CI_REGISTRY_REPOSITORY/statistics-service


     - docker build -t $CI_REGISTRY_REPOSITORY/turbine-stream-service ./turbine-stream-service
     - docker push $CI_REGISTRY_REPOSITORY/turbine-stream-service


#       # - docker push $CI_REGISTRY_REPOSITORY




# Выкат на сервер
deploy:
    stage: deploy
    # выкатываем только ветку master
    only:
        - master
    # для этой ступени другие команды инициализации
    before_script:
        # устанавливаем зависимости Fabric, bash и rsync
        - apk add --no-cache openssh openssh-client py-pip py-crypto bash rsync
        # устанавливаем Fabric
        - pip install fabric==1.12.0
        # добавляем приватный ключ для выката
        - eval $(ssh-agent -s)
        - bash -c 'ssh-add <(echo "$DEPLOY_KEY")'
        - mkdir -p ~/.ssh
        - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    script:
        - fab -H $DEPLOY_ADDR deploy
      #  - scp docker-compose.prod.yml initflow@$DEPLOY_ADDR:/srv/mywebapp/docker-compose.prod.yml
      #  - scp app.sh initflow@$DEPLOY_ADDR:/srv/mywebapp/app.sh
